//
//  DropitViewController.swift
//  Dropit
//
//  Created by Admin on 7/24/16.
//  Copyright © 2016 yusup. All rights reserved.
//

import UIKit

class DropitViewController: UIViewController,UIDynamicAnimatorDelegate
    
{
    @IBOutlet weak var gemeView: UIView!
    
    let garvity = UIGravityBehavior()
    //    ---------
    
    lazy var animator: UIDynamicAnimator = {
        
        let lazilyCreaterDynamicAnimator = UIDynamicAnimator(referenceView: self.gemeView)
        lazilyCreaterDynamicAnimator.delegate  = self
        
        return lazilyCreaterDynamicAnimator
    }()
    //    ---------
    
    let dropitBegavior=DropBehavior()
    
    override func viewDidLoad() {
        
        animator.addBehavior(dropitBegavior)
        
    }
    
    
    func dynamicAnimatorDidPause(animator: UIDynamicAnimator) {
        removeCompletedRow()
    }
    
    
    var dropRerRow = 20
    var dropSize: CGSize{
        
        let size = gemeView.bounds.size.width / CGFloat(dropRerRow)
        
        return CGSize(width:size, height:size)
        
    }
    
    @IBAction func drop(sender: UIPanGestureRecognizer) {
        drop()
    }
    
    
    func drop() {
        var frame = CGRect(origin: CGPointZero, size: dropSize)
        frame.origin.x = CGFloat.random(dropRerRow) * dropSize.width
        
        
        let dropView = UIView(frame: frame)
        dropView.backgroundColor=UIColor.random
        
        dropitBegavior.addDrop(dropView)
        
    }
    
    
    
    
    
    func removeCompletedRow ()
    {
        var dropsToremove = [UIView]()
        var dropFrame = CGRect(x: 0, y: gemeView.frame.maxY, width: dropSize.width, height: dropSize.height)
        
        
        repeat {
            dropFrame.origin.y -= dropSize.height
            dropFrame.origin.x = 0
            var dropsFound = [UIView]()
            var rowIsComplete = true
            
            for _ in 0 ..< dropRerRow {
                if let hitView = gemeView.hitTest(CGPoint(x: dropFrame.midX, y: dropFrame.midY), withEvent: nil) {
                    if hitView.superview == gemeView {
                        dropsFound.append(hitView)
                    } else {
                        
                        rowIsComplete = false
                    }
                }
                dropFrame.origin.x += dropSize.width
            }
            
            if rowIsComplete {
                dropsToremove += dropsFound
            }
            
            
        }while dropsToremove.count == 0 && dropFrame.origin.y > 0
        
        for drop in dropsToremove {
            dropitBegavior.removeDrop(drop)
        }
        
    
    
    }
    
}
    //
    
    
    
    
    private extension CGFloat {
        static func random(max: Int) ->CGFloat{
            return CGFloat(arc4random() % UInt32(max))
        }
    }
    
    
    private extension UIColor {
        class var random: UIColor {
            switch arc4random()%5 {
            case 0: return UIColor.greenColor();
            case 1: return UIColor.blueColor();
            case 2: return UIColor.orangeColor();
            case 3: return UIColor.redColor();
            case 4: return UIColor.purpleColor();
            case 5: return UIColor.blackColor();
            default:return UIColor.blackColor()
            }
        }
    }
    
    









